-- Dual plasmas with nice little interference effect (kinda) and optional antialiasing.
-- By Mic, 2000
--
-- I don't remember where I got the plasma-calculations-thingy from (probably some old
-- QB program..).
--
-- You can interact with this program by using the following keys:
--
-- [1]: Use palette #1
-- [2]: Use palette #2
-- [t]: Turn antialiasing ON
-- [y]: Turn antialiasing OFF



without warning
without type_check


include m19lib_l.e


constant PI=3.141592654

sequence pal,pal2
sequence table
sequence ptr
atom vscreen,vscreen2
integer key,antialiasing,dual


constant asm_ptr=allocate(4*4),
         asm_table=allocate(256),
         asm_dbuf=allocate(64000*4),
         asm_screenpos=allocate(4),
         asm_hptr=allocate(8)


vscreen=allocate(64000)
if (asm_dbuf<=0 or vscreen<=0) then
 puts(1,"Doh! Out of memory.\n")
 abort(1)
end if

table=repeat(0,256)
for i=0 to 255 do
 table[i+1]=floor((cos(i*360.0/255.0*PI/180.0)*32)+32)
end for
poke(asm_table,table)

ptr={0,0,0,0}
integer hptr1,hptr2,vptr1,vptr2
integer screenpos,x,y

mem_set(asm_dbuf,0,64000)

pal=repeat({0,0,0},256)
pal2=pal



for i=0 to 63 do
 pal[i+1]={i,0,i}
 pal[i+65]={63-i,0,63-i}
 pal[i+129]={i,0,i}
 pal[i+193]={63-i,0,63-i}
end for

for i=0 to 63 do
 pal2[i+1]={i,0,0}
 pal2[i+65]={63-i,i,0}
 pal2[i+129]={0,63-i,i}
 pal2[i+193]={0,0,63-i}
end for




puts(1,"Dual plasma effect with interference and optional antialiasing.\n")
puts(1,"By Mic, 2000\n\n")
puts(1,"Keys are:\n")
puts(1," [1]: Use palette #1\n")
puts(1," [2]: Use palette #2\n")
puts(1," [d]: Dual plasmas with interference\n")
puts(1," [s]: Single plasma\n")
puts(1," [t]: Turn antialiasing ON (only noticable in dual-plasma mode)\n")
puts(1," [y]: Turn antialiasing OFF\n")
puts(1," [Esc]: Exit program\n")
puts(1,"\nWaiting for keypress...")
while get_key()=-1 do
end while


set_vga()
set_pal(pal)


constant plasma=get_asm(
"pusha cld "&
"mov ecx,320 "&
"mov ebp,4 "&
"mov esi,255 "&
"xloop: "&
"mov ebx,2 "&
"add [hptr1],ebx "&
"inc ebx "&
"add [hptr2],ebx "&
"mov ebx,[hptr1] "&
"mov edx,[hptr2] "&
"and ebx,esi "&
"and edx,esi "&
"mov eax,[table + ebx] "&
"add eax,[table + edx] "&
"mov ebx,vptr1 "&
"mov edx,vptr2 "&
"and ebx,esi "&
"and edx,esi "&
"add eax,[table + ebx] "&
"add eax,[table + edx] "&
"mov ebx,[screenpos] "&
"mov [doublebuf + ebx],eax "&
"add [screenpos],ebp "&
"dec ecx "&
"jnz xloop "&
"popa ret")
constant asm_vptr1=plasma+get_param("vptr1")
constant asm_vptr2=plasma+get_param("vptr2")
resolve_param("hptr1",asm_hptr)
resolve_param("hptr2",asm_hptr+4)
resolve_param("table",asm_table)
resolve_param("doublebuf",asm_dbuf)
resolve_param("screenpos",asm_screenpos)


constant draw=get_asm(
"pusha cld "&
"mov edi,dest "&
"mov esi,dbuf "&
"mov ecx,64000 "&
"draw_@loop: "&
"lodsd "&
"stosb "&
"loop draw_@loop: "&
"popa ret")
constant draw_dest=draw+get_param("dest")
resolve_param("dbuf",asm_dbuf)


constant draw_reverse_mask=get_asm(
"pusha cld "&
"mov edi,dest "&
"mov esi,dbuf "&
"sub esi,4 "&
"mov ecx,64000 "&
"draw_rev_@loop: "&
"mov eax,[esi + ecx*4] "&
"mov bl,[edi] "&
"xor al,bl "&
"stosb "&
"loop draw_rev_@loop: "&
"popa ret")
constant draw_rev_dest=draw_reverse_mask+get_param("dest")
resolve_param("dbuf",asm_dbuf)

constant triLin_alias=get_asm(
"pusha cld "&
"mov edi,triLinAddr "&
"add edi,321 "&
"mov ecx,198 "&
"triLin_yloop: "&
"mov edx,ecx "&
"mov ecx,318 "&
"triLin_xloop: "&
"xor ax,ax "&
"xor bx,bx "&
"mov al,[edi-1] "&	--col=point(x-1,y)
"mov bx,ax "&
"mov al,[edi+1] "&	--col+=point(x+1,y)
"add bx,ax "&
"mov al,[edi-320] "&	--col+=point(x,y-1)
"add bx,ax "&
"mov al,[edi+320] "&	--col+=point(x,y+1)
"add bx,ax "&
"mov al,[edi-321] "&	--col+=point(x-1,y-1)
"add bx,ax "&
"mov al,[edi-319] "&	--col+=point(x+1,y-1)
"add bx,ax "&
"mov al,[edi+321] "&	--col+=point(x+1,y+1)
"add bx,ax "&
"mov al,[edi+319] "&	--col+=point(x-1,y+1)
"add bx,ax "&
"shr bx,3 "&		--col/=8
"mov al,[edi] "&	--col+=point(x,y)
"add ax,bx "&
"shr ax,1 "&		--col/=2
"stosb "&		--point(x,y)=col
"dec cx "&
"jnz triLin_xloop "&
"inc edi inc edi "&
"mov ecx,edx "&
"dec cx "&
"jnz triLin_yloop "&
"popa ret")
resolve_param("triLinAddr",vscreen)


antialiasing=0
key=0
dual=0

while key!=27 do
 key=get_key()
 if key='1' then set_pal(pal)
 elsif key='2' then set_pal(pal2)
 elsif key='d' then dual=1
 elsif key='s' then dual=0
 elsif key='t' then antialiasing=1
 elsif key='y' then antialiasing=0
 end if
 poke4(asm_screenpos,0)
 vptr1=ptr[3]
 vptr2=ptr[4]
 y=0
 while y<200 do
  vptr1+=1
  vptr2+=2
  hptr1=ptr[1]
  hptr2=ptr[2]
  poke4(asm_hptr,hptr1)
  poke4(asm_hptr+4,hptr2)
  poke4(asm_vptr1,vptr1)
  poke4(asm_vptr2,vptr2)
  call(plasma)
  y+=1
 end while
 ptr[1]-=3
 ptr[2]+=2
 ptr[3]-=3
 ptr[4]+=1
 poke4(draw_dest,vscreen)
 call(draw) 
 poke4(draw_rev_dest,vscreen)
 if dual then call(draw_reverse_mask) end if
 if antialiasing then call(triLin_alias) end if
 while and_bits(Input(#3DA),8) do		
 end while					
 while (and_bits(Input(#3DA),8)=0) do	
 end while 					
 asm_copy_screen(vscreen,#A0000)
end while
 
free(vscreen)
free(asm_dbuf)
free(asm_table)
restore_graphics()

